/***************************************************************************
 *            net_dir_scan.c
 *
 *  Fri Oct 24 11:27:21 2003
 *  Copyright  2003  Phil Kett
 *  pkett@genesis-midi.com
 ****************************************************************************/

#include "../include/remsync.h"
#include <sys/socket.h>

void
net_dir_scan (int fd, char *basedir, int depth)
{
	char curdir[BIG_BUF], message[BIG_BUF], mode[BIG_BUF];
	struct dirent *d;
	DIR *dir;
	int checksum, isdir;

	dir = opendir (basedir);
	getperms(basedir, mode);
	syslog(LOG_INFO, "Basedir is %s\n", basedir);
	sprintf(message, "CSUM:%s:%s:DIRECTORY\r\n", basedir, mode);
	send (fd, message, strlen(message), 0);
	
	while ((d = readdir (dir)))
	{
		if (strcmp (d->d_name, ".") != 0
		    && strcmp (d->d_name, "..") != 0)
		{
			sprintf (curdir, "%s%s", basedir, d->d_name);
			isdir = is_a_dir (curdir);
			if (isdir == 1)
			{
				depth++;
				//printf ("Directory depth %d\n", depth);
				checkslash(curdir);
				net_dir_scan (fd, curdir, depth);
			}
			else if (isdir == 0)
			{
				/* Size??? */
				getperms(curdir, mode);
				checksum = cksum (curdir);
				sprintf (message, "CSUM:%s:%s:%d\r\n", curdir,
					 mode, checksum);
				send (fd, message, strlen (message), 0);
			}
		}
	}
	closedir (dir);
}
